Ext.namespace("dSS", "dSS.config", "dSS.devprops");

dSS.devprops.Loaders = {
    "OUTPUT_MODE"               : 0,
    "COMBINED_PB_OUTMODE"       : 1,
    "SHADE_OPEN_CLOSE"          : 2,
    "SHADE_CLOSE_OPEN"          : 3,
    "SHADE_MTIME_FINS"          : 4,
    "SHADE_DELAY_TIME"          : 5,
    "SHADE_DIR_OF_TRAVEL_RTIME_CH" : 6,
    "SHADE_MTIME_BLINK"         : 7,
    "SHADE_FTEND_TRESHOLDENDSW" : 8, // 0x38 follow up time 0x39 threshold endsw
    "SHADE_NUMST_MTIME_FTUNE"   : 9, // 0x3a num steps 0x3b motion time tune
    "SHADE_CALIBRATION_ALLOWED" : 10
};

// config options:
// defaultFailMsg: default failure message in case the server does not
//                 reply with anything meaningful
// url: request URL as in Ext.Ajax.request
// params: URL parameters as in Ext.Ajax.request
// scop: objet scope
dSS.devprops.Loader = Ext.extend(Ext.util.Observable, {
    constructor: function(config){
        this.defaultFailMsg = config.defaultFailMsg;
        this.addEvents('loadcomplete');
        this.url = config.url;
        this.loaderId = config.loaderId;
        this.params = config.params;
        this.scope = this;
        if (config.scope !== undefined) {
            this.scope = config.scope;
        }

        this.listeners = config.listeners;

        this.enableBubble('loadcomplete');

        dSS.devprops.Loader.superclass.constructor.call(this, config);
    },

    load: function() {
        this.tid = Ext.Ajax.request({
            url: this.url,
            method: 'GET',
            params: this.params,
            scope: this.scope,
            success: function(response) {
                var jsonData;
                var ret = {};
                try {
                    jsonData = Ext.util.JSON.decode(response.responseText);
                } catch (err) {
                    jsonData.ok = false;
                    jsonData.message = this.defaultFailMsg;
                }
                ret.json = jsonData;
                ret.loader = this.loaderId;
                this.fireEvent('loadcomplete', ret);
            },
            failure: function(response) {
                var jsonData;
                var ret = {};
                try {
                    jsonData = Ext.util.JSON.decode(response.responseText);
                } catch (err) {
                    jsonData.ok = false;
                    jsonData.message = this.defaultFailMsg;
                }
                ret.json = jsonData;
                ret.loader = this.loaderId;
                this.fireEvent('loadcomplete', ret);
            }
        });
        return this.tid;
    }
});

Ext.reg('dssdevpropsloader', dSS.devprops.Loader);

